#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include<signal.h>
#include<sys/time.h>

#define LOOP_STR "\\|/-"

char fx_loop(){
  static int idx = 0;
  static const char loop_str[] = LOOP_STR;
  /*static const int length = strlen(loop_str);*/
  static const int length = 4;/* to avoid compilation warning*/

  idx++;
  idx = idx % length;
  return loop_str[idx];
}

char* truncate_text_too_long(char* original, int size){
  static char new_text[1024];
  int original_size = strlen(original);
  if(original_size > size){
    memcpy(new_text, original, size);
    new_text[size] = '\0';
  }else
    return original;

  return new_text;
}

/* progress bar stuffs **** inspired by git progress.c  */

/* what means 'volatile' and 'sig_atomic_t'? */
static volatile sig_atomic_t progress_update;

struct progress{
  char* title;
  unsigned int total;
  float old_percentual;
  int old_value;
  struct timeval old_time;
};

static void progress_interval(int signal){
  (void)signal;
  progress_update = 1;
}

#define DIV (1024*1024)
int progress_display(struct progress* p, int value){
  float percentual;
  unsigned int speed;
  struct timeval tv;
  unsigned int misecs;
  percentual = (float)value / p->total * 100 ;
  if( progress_update && ( percentual > p->old_percentual ) ){
    gettimeofday(&tv, NULL);
    misecs = (tv.tv_sec - p->old_time.tv_sec) * 1024;
    misecs += (int)(tv.tv_usec - p->old_time.tv_usec) / 977;
    speed = ( value - p->old_value ) / misecs;
    fprintf(stderr, "%s: %3.0f%% (%d/%d) %u KiB\r",
        p->title,percentual, value/DIV, p->total/DIV, speed);

    p->old_time = tv;
    p->old_value = value;
    p->old_percentual = percentual;
  }

  progress_update = 0;
  return 0;
}

struct progress* progress_start(char* title, int total){
  struct progress* p = malloc(sizeof(struct progress));
	struct sigaction sa;
	struct itimerval v;
  p->title = title;
  p->total = total;

	memset(&sa, 0, sizeof(sa));
	sa.sa_handler = progress_interval;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;/*with _XOPEN complains about undeclared*/
	sigaction(SIGALRM, &sa, NULL);

	v.it_interval.tv_sec = 1;
	v.it_interval.tv_usec = 0;
	v.it_value = v.it_interval;
	setitimer(ITIMER_REAL, &v, NULL);

  return p;
}
