#include "openssl/ssl.h"
#include "openssl/bio.h"
#include "openssl/err.h"
#include "stdio.h"
#include<unistd.h>
#include "string.h"
#include<sys/socket.h>
#include<arpa/inet.h>

#include<libtext.h>
#include<openssl-routine.h>
#include<transfer-routine.h>

#define TRSIZE 1024

int main(int argc, char* argv[]){
  BIO * bio;
	int fsize;
	char filenamesize, filename[TRSIZE],* hostport, buf[TRSIZE];
	int fdout, nread, nwrite, ntotalwrite, ntotalreceived = 0;

	if( argc < 2 ){
		return 1;
	}

	hostport = argv[1];

  /* Set up the library */
  SSL_library_init();

  SSL_load_error_strings();
  OpenSSL_add_all_algorithms();

	bio = ssl_client_connect(hostport);

	if( BIO_read(bio, &filenamesize, 1) < 0 )
		ERR_print_errors_fp(stderr);

	if( BIO_read(bio, filename, filenamesize) < 0 )
		ERR_print_errors_fp(stderr);

	filename[(int)filenamesize] = '\0';

	fdout = get_fd_out(filename);
	if( fdout < 0 ){
		perror("* error writing file");
		return 1;
	}

	if( BIO_read(bio, &fsize, 4) < 0 )
		ERR_print_errors_fp(stderr);


	fprintf(stderr, "* downloading %s (%d bytes)\n", filename, fsize);
	struct progress* p =
		progress_start(truncate_text_too_long(filename, 40), fsize);
	while(1){
		nread = BIO_read(bio, buf, TRSIZE);
		if( nread <= 0){
			ERR_print_errors_fp(stderr);
			return 1;
		}
		ntotalwrite = 0;
		while( nread > ntotalwrite){
			nwrite = write(fdout, buf + ntotalwrite, nread - ntotalwrite);
			if(nwrite < 0){
				perror("* error writing file");
				return 1;
			}
			ntotalwrite += nwrite;
		}
		ntotalreceived += ntotalwrite;
		//fprintf(stderr, "%d\n", ntotalreceived);
		progress_display(p, ntotalreceived);
	}/*end loop*/

  //io_loop(bio);

	close(fdout);
  return 0;
}
